/* ************************************************************************** */
/*                                         _____                              */
/*  Engine.hpp                            |  ___| _   ____   ___              */
/*  Project : C-Engine                    | |_	 | | |  __| / _ \             */
/*                                        |  _|	 | | | |=  |  __/             */
/*  By: Fife <wasabifife@gmail.com>       |_|	 |_| |_|    \___|  	          */
/*                                                                            */
/*                                                                            */
/* ************************************************************************** */

#ifndef CENGINE_ENGINE_HPP
#define CENGINE_ENGINE_HPP

#include "..\Rework\CEngine.hpp"

    class Engine
    {
        public:

            Engine(); //Constructeur

            void StartGame(); //Lance le jeu
            void InitGame(); //Initialise le jeu
            void StopGame(); //Quitte le jeu

            void ShowFps(); //Affiche les FPS  l'cran
            void HideFps(); //Cache les FPS de l'cran
            void SetFpsWish(int v); //Set le nombre de FPS

            void AddObject( Object * v); //Ajout un objet au moteur
            void DelObject( Object * v); //Supprime l'objet
            void DelAllObject(); //Supprime tout les objets

            Object ** GetListeObject(); //Renvoie un pointeur sur le tableau d'objet
            int GetNbObject(); //Renvoie le nombre d'objet lis au moteur

            void ExecuteScript();
            void AppliedForce();
            void Draw();

            AABB * GetScreen();
            void MoveScreen( int x ,int y);
            void MiddleScreen(int x , int y , bool fixe = true);

            void UpdateRelativePosition();

            #ifdef CE_MAP

            World * GetWorld();
            void SetWorld( World * v);

            #endif

        private:

            bool execute;

            int fpswish;
            bool fps;

            Object ** listeObject; //Tableau d'objet utilis dans le cas ou il n'y a pas de map.
            int nbobject; //Nombre d'objet lis au moteur. nb = Nombre

            AABB screen;

            #ifdef CE_MAP

            World * engineWorld;

            #endif

    };

#endif
